<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>
<body>
<div class="container">
  <div class="text-center mt-2 mb-2">
    <h2>F120 - Quản trị Order</h2>
  </div>
  <div class="jumbotron container">
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="voucherCodeInput">Loại Pizza</label>
      </div>
      <div class="col-sm-6">
        <select id="gPizzaTypeSelect" class="form-control">

        </select>
      </div>
      <div class="col-sm-3">
        <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
      </div>
    </div>
</div>

<div class="container">
  <table class="table table-bordered table-striped table-hover" id="order-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã order</th>
        <th>Loại Pizza</th>
        <th>Tên khách hàng</th>
        <th>Ngày đặt hàng</th>
        <th>Trạng thái</th>
        <th>Action</th>
      </tr>
    </thead>
  </table>
</div>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // mảng orders
  var gOrderObjects = [
      {
          "id": 2,
          "orderCode": "12456",
          "gPizzaTypeId": 20,
          "customerName": "Do Van Linh",
          "date": "13/01/2021",
          "status": "completed"
      },
      {
          "id": 3,
          "orderCode": "22456",
          "gPizzaTypeId": 10,
          "customerName": "Huynh Van Nam",
          "date": "13/01/2021",
          "status": "new"
      },
      {
          "id": 4,
          "orderCode": "22986",
          "gPizzaTypeId": 15,
          "customerName": "Do Thi Lan",
          "date": "14/01/2021",
          "status": "completed"
      },
      {
          "id": 5,
          "orderCode": "42086",
          "gPizzaTypeId": 10,
          "customerName": "Dinh Chau Ngoc",
          "date": "14/01/2021",
          "status": "completed"
      },
      {
          "id": 6,
          "orderCode": "56086",
          "gPizzaTypeId": 15,
          "customerName": "Dang Tien Minh",
          "date": "15/01/2021",
          "status": "new"
      },
      {
          "id": 7,
          "orderCode": "90081",
          "gPizzaTypeId": 20,
          "customerName": "Do Hong Quan",
          "date": "15/01/2021",
          "status": "inprogress"
      },
      {
          "id": 8,
          "orderCode": "67012",
          "gPizzaTypeId": 15,
          "customerName": "Bui Thanh Phuoc",
          "date": "15/01/2021",
          "status": "inprogress"
      }
    ];
  
  // mảng pizza Type
  var gPizzaType = [
    {
      typeId: 10,
      typeName: "Hải Sản"
    },
    {
      typeId: 15,
      typeName: "Bò bít tết"
    },
    {
      typeId: 20,
      typeName: "Thịt gà"
    }
  ];
  var gCOL_NAMES = ["id", "orderCode", "gPizzaTypeId", "customerName", "date", "status", "action"];
  var gCOL_ID = 0;
  var gCOL_ORDER_CODE = 1;
  var gCOL_PIZZA_TYPE_ID = 2;
  var gCOL_CUSTOMER_NAME = 3;
  var gCOL_DATE = 4;
  var gCOL_STATUS = 5;
  var gCOL_ACTION = 6;  
  var gSTT = 0;

  var gOrderDataTable = $("#order-table").DataTable({
      columns : [
        { data : gCOL_NAMES[gCOL_ID] },
        { data : gCOL_NAMES[gCOL_ORDER_CODE] },
        { data : gCOL_NAMES[gCOL_PIZZA_TYPE_ID] },
        { data : gCOL_NAMES[gCOL_CUSTOMER_NAME] },
        { data : gCOL_NAMES[gCOL_DATE] },
        { data : gCOL_NAMES[gCOL_STATUS] },
        { data : gCOL_NAMES[gCOL_ACTION] },
      ],
      columnDefs : [
        {
          targets : gCOL_ID,
          render:function() {
            return ++gSTT;
          }
        },
        {
          targets : gCOL_PIZZA_TYPE_ID,
          render:function(paramTypeId) {
            return getPizzaNameByTypeId(paramTypeId);
          }
        },        
        {
          targets : gCOL_ACTION,
          defaultContent : `
          <i title="Sửa dữ liệu" class="fa-solid fa-pen-to-square" style="cursor:pointer; color: blue;"></i>
          <i title="Xóa dữ liệu" class="fa-solid fa-trash" style="cursor:pointer; color: red;"></i>
          `
        }
      ]

  });
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  //gọi sự kiện load trang
  onPageLoading();

  //thêm sự kiện cho nút locj
  $("#btn-filter-order").on("click", function() {
    onBtnFilterOrderClick();
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  //hàm xử lý khi load trang
  function onPageLoading() {
    //đổ dữ liệu vào datatable
    loadOrderToTable(gOrderObjects);

    //đổ dữ liệu vào select pizza type
    loadPizzaTypeToSelect(gPizzaType);
  }

  //hàm xử lý sự kiện lọc dữ liệu
  function onBtnFilterOrderClick() {
    //B0: khai báo biến
    var vFilterParam = {
      pizzaTypeId : 0
    }

    //B1: Thu thập dữ liệu
    getFilterPizzaParam(vFilterParam);

    //B2: Kiểm tra dữ liệu

    //B3: Xử lý và hiển thị kết quả
    filterOrderData(vFilterParam);
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // hàm trả về pizzaTypeName dựa vào typeId
  function getPizzaNameByTypeId(paramTypeId) {
    "use strict";
    var vPizzaTypeName = "";
    var vIndex = 0;
    var vIsTypeFound = false;
    while(!vIsTypeFound && vIndex < gPizzaType.length) {
      if(gPizzaType[vIndex].typeId === paramTypeId) {
        vIsTypeFound = true;
        vPizzaTypeName = gPizzaType[vIndex].typeName;
      }
      else {
        vIndex ++;
      }
    }
    return vPizzaTypeName;
  }

  //hàm load dữ liệu vào data table
  function loadOrderToTable(paramOrderObjects) {
    gSTT = 0;
    gOrderDataTable.clear();
    gOrderDataTable.rows.add(paramOrderObjects);
    gOrderDataTable.draw();
  }

  //hàm load dữ liệu pizza vào select box
  function loadPizzaTypeToSelect(paramPizzaType) {
    var vPizzaTypeSelect = $("#gPizzaTypeSelect");
    vPizzaTypeSelect.append($("<option>", {
      value:0,
      text:"chọn loại pizza"
    }));

    for (var bI = 0; bI <paramPizzaType.length; bI++ ) {
      vPizzaTypeSelect.append($("<option>", {
        value:paramPizzaType[bI].typeId,
        text:paramPizzaType[bI].typeName
      }));
    }
  }

  //hàm thu thập dữ liệu lọc
  function getFilterPizzaParam(paramFilter) {
    paramFilter.pizzaTypeId = $("#gPizzaTypeSelect").val();
  }

  //hàm lọc và hiển thị dữ liệu order
  function filterOrderData(paramFilter) {
    //lọc dữ liệu
    var vResult = [];
    vResult = gOrderObjects.filter(function(item) {
      return (paramFilter.pizzaTypeId == 0 || item.gPizzaTypeId == paramFilter.pizzaTypeId)
    })

    //hiển thị dữ liệu
    loadOrderToTable(vResult);
  }
</script>
</body>
</html>